
import java.util.*;
import javax.swing.*;
import org.gjt.sp.jedit.*;
import org.gjt.sp.jedit.textarea.*;
import org.gjt.sp.jedit.gui.*;
import org.gjt.sp.jedit.msg.*;
import com.xrefactory.jedit.*;


// NO CODE HERE, put here only very necesary code related to jEdit!!!

public class XrefactoryPlugin extends EBPlugin {

	public void start() {
		s.setGlobalValues();
		Random random = new Random();
		s.currentTmpFileCounter = random.nextInt(1000);
		s.tmpFileStep = random.nextInt(10) + 1;
		random = null;
//&		EditBus.addToNamedList(DockableWindow.DOCKABLE_WINDOW_LIST, s.dockableBrowserWindowName);
//&		EditBus.addToNamedList(DockableWindow.DOCKABLE_WINDOW_LIST, s.dockableRetrieverWindowName);
	}

	public void stop() {
		// save some values
		if (jEdit.getFirstView()!=null) {
			BrowserTopPanel t = s.getBrowser(jEdit.getFirstView());
			if (t!=null) {
				Opt.setBrowserTreeDividerPosition((int)t.treePanel.getSize().getWidth());
			}
		}
								  
	}

/*
    public void handleMessage(EBMessage message) {
        if(message instanceof CreateDockableWindow) {
            CreateDockableWindow cmsg = (CreateDockableWindow) message;
            if (cmsg.getDockableWindowName().equals(s.dockableBrowserWindowName)) {
                DockableWindow win = new BrowserDialog.BrowserPanel(cmsg.getView());
                //& DockableWindow win = new DockableBrowser(cmsg.getView());
                cmsg.setDockableWindow(win);
            } else if (cmsg.getDockableWindowName().equals(s.dockableRetrieverWindowName)) {
                cmsg.setDockableWindow(new SymbolRetriever(cmsg.getView()));
            }

        }
    }
*/

    public void createMenuItems(Vector menuItems) {
        menuItems.addElement(GUIUtilities.loadMenu("xrefactory.menu"));
    }

	public void createOptionPanes(OptionsDialog od) {
		OptionGroup xrefactoryGroup = new OptionGroup("xrefactory");
		xrefactoryGroup.addOptionPane(new OptionsForJeditGeneral());
		xrefactoryGroup.addOptionPane(new OptionsForJeditProjects());
		//&xrefactoryGroup.addOptionPane(new OptionsForJeditCompletion());
		od.addOptionGroup(xrefactoryGroup);
	}

	private static DispatchData mainBrowserNoFileInvocation(View view, String[] options) {
		//& s.setGlobalValues(view,true);
		DispatchData ndata = new DispatchData(s.xbTask, view);
		XrefCharBuffer receipt = ndata.xTask.callProcess(options, ndata);
		Dispatch.dispatch(receipt, ndata);
		return ndata;
	}
	private static DispatchData mainBrowserInvocation(View view, String[] options) {
		//& s.setGlobalValues(view,true);
		DispatchData ndata = new DispatchData(s.xbTask, view);
		XrefCharBuffer receipt = ndata.xTask.callProcessOnFile(options, ndata);
		Dispatch.dispatch(receipt, ndata);
		return ndata;
	}
	private static DispatchData mainBrowserInvocation(View view, String option) {
		return(mainBrowserInvocation(view, new String[]{option}));
	}

	public static void completion(View view) {
		s.setGlobalValues(view,true);
		CompletionDialog.completion(view);
	}

	public static void pushAndGotoDefinition(View view) {
		s.setGlobalValues(view,true);
		if (s.activeProject!=null) {
			DispatchData ndata = new DispatchData(s.xbTask, view);
			new Push(new String[]{"-olcxpush"}, ndata);
			s.displayProjectInformation();
		}
	}

	public static void popAndReturn(View view) {
		s.setGlobalValues(view,true);
		if (s.activeProject!=null) {
			DispatchData data = mainBrowserNoFileInvocation(view, new String[]{"-olcxpop"});
			if (! data.panic) s.browserNeedsToUpdate(view);
			s.displayProjectInformation();
		}
	}

	public static void previousReference(View view) {
		s.setGlobalValues(view,true);
		if (s.activeProject!=null) {
			DispatchData data = mainBrowserNoFileInvocation(view, new String[]{"-olcxminus"});
			if (! data.panic) {
				if (s.browserIsDisplayed(view)) {
					s.getBrowser(view).referencesPanel.updateSelection();
				}
			}
			s.displayProjectInformation();
		}
	}

	public static void nextReference(View view) {
		s.setGlobalValues(view,true);
		if (s.activeProject!=null) {
			DispatchData data = mainBrowserNoFileInvocation(view, new String[]{"-olcxplus"});
			if (! data.panic) {
				if (s.browserIsDisplayed(view)) {
					s.getBrowser(view).referencesPanel.updateSelection();
				}
			}
			s.displayProjectInformation();
		}
	}

	public static void killXrefTask(View view) {
		s.setGlobalValues(view,true);
		if (s.xbTask != null) s.xbTask.killThis(true);
	}


	public static void browser(View view) {
		s.setGlobalValues(view,true);
		if (s.activeProject!=null) {
			view.getDockableWindowManager().showDockableWindow(s.dockableBrowserWindowName);
			DispatchData ndata = new DispatchData(s.xbTask, view);
			new Push(new String[]{"-olcxpushonly", "-olnodialog"}, ndata);
		}
	}

	public static void refactor(View view) {
		s.setGlobalValues(view,true);
		if (s.activeProject!=null) {
			mainBrowserInvocation(view, "-olcxgetrefactorings");
			s.displayProjectInformation();
		}
	}

	public static void viewClassTree(View view) {
		s.setGlobalValues(view,true);
		if (s.activeProject!=null) {
			mainBrowserInvocation(view, "-olcxclasstree");
			s.displayProjectInformation();
		}
	}

	public static void retrieveSymbol(View view) {
		s.setGlobalValues(view,true);
		if (s.activeProject!=null) {
			s.view.getDockableWindowManager().showDockableWindow(s.dockableRetrieverWindowName);
			s.displayProjectInformation();
		}
	}

	public static void registration(View view) {
		s.setGlobalValues(view, false);
		new RegistrationDialog();
	}

}

