package sk.xref.java2html;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.filechooser.*;
import javax.swing.plaf.basic.*;
import java.util.*;
import java.io.*;

class FileBrowser extends Container {

	DirectoryTree tree;
	JComboBox drives;

	class DriveComboBoxListener implements ActionListener {
		public void  actionPerformed( ActionEvent e) {
			File drive = (File)drives.getSelectedItem();
			tree.setModel(new DefaultTreeModel(new DirectoryNode(null, drive)));
			tree.repaint();
		}
	}

	FileBrowser(String root) {
		int y, height;
		tree = new DirectoryTree(new File(root));
		setLayout(new GridBagLayout());
		GridBagConstraints gbc = new GridBagConstraints();
		y=-1;

		// ---------------------- output
		y++;
		File[] ff = FileSystemView.getFileSystemView().getRoots();
		gbc.gridx = 0; gbc.gridy = y; 
		gbc.gridwidth = 1; gbc.gridheight = 1;
		gbc.weightx = 1; gbc.weighty = 1; gbc.fill = GridBagConstraints.HORIZONTAL;
		drives = new JComboBox(ff);
		drives.setSelectedItem(new File(root));
		drives.addActionListener(new DriveComboBoxListener());
		add(drives, gbc);

		y++;
		gbc.gridx = 0; gbc.gridy = y; 
		gbc.gridwidth = 1; gbc.gridheight = 1;
		gbc.weightx = 1; gbc.weighty = 10000; gbc.fill = GridBagConstraints.BOTH;
		add(new JScrollPane(tree), gbc);
	}
}
