package sk.xref.java2html;
import javax.swing.*;

class XrefExtraProcessJava2Html extends XrefExtraProcess {

	private Main main;

	public void handleOutputLine(String ss) {
		main.output.append(ss);
		main.output.append("\n");
	}

	public void kill() {
		if (pp != null) {
			main.stopButton.setEnabled(false);
			super.kill();
		}
	}

	XrefExtraProcessJava2Html(Main main, String[] command, String commandToShow) {
		super(command);
		this.main = main;
		main.output.setText("");
		handleOutputLine(commandToShow);
		handleOutputLine("");
		main.stopButton.setEnabled(true);
		new Thread(this).start();
	}
}
