
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2002.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
static char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#ifndef STDINC__H
#define STDINC__H
#if defined(__WIN32) && (! defined(__WIN32__))
#define __WIN32__ 1
#endif
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#endif
#include "head2.h"
#include "proto.h"
typedef union {
        int integer;
        unsigned unsign;
        S_symbol *symbol;
        S_symbolList *symbolList;
        S_typeModifiers *typeModif;
        S_typeModifiersList *typeModifList;
        S_freeTrail *trail;
        S_idIdent *idIdent;
        S_idIdentList *idlist;
        S_exprTokenType exprType;
        S_intPair intpair;
        S_whileExtractData *whiledata;
        S_position position;
        S_unsPositionPair unsPositionPair;
        S_symbolPositionPair symbolPositionPair;
        S_symbolPositionLstPair symbolPositionLstPair;
        S_positionLst *positionLst;
        S_typeModifiersListPositionLstPair typeModifiersListPositionLstPair;
} MAINYYSTYPE;
extern MAINYYSTYPE yylval;
short cexpyylhs[] = { -1,
    0, 0, 1, 1, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 1, 1, 1, 1,
};
short cexpyylen[] = { 2,
    1, 1, 3, 3, 3, 3, 3, 3, 3, 3,
    3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
    5, 3, 2, 2, 2, 3, 1,
};
short cexpyydefred[] = { 0,
    2, 27, 0, 0, 0, 0, 0, 0, 23, 24,
   25, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 26, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    3, 4, 5, 0, 0,
};
short cexpyydgoto[] = { 7,
    8,
};
short cexpyysindex[] = { -29,
    0, 0, -19, -19, -19, -19, 0, 414, 0, 0,
    0, 338, -19, -19, -19, -19, -19, -19, -19, -19,
  -19, -19, -19, -19, -19, -19, -19, -19, -19, -19,
  -19, -19, 0, 480, 480, -30, -30, -37, -37, 468,
  454, 426, 366, 326, 326, 438, -30, -30, -17, -17,
    0, 0, 0, -19, 426,
};
short cexpyyrindex[] = { 0,
    0, 0, 0, 0, 0, 0, 0, 2, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 112, 128, 73, 83, 24, 36, 140,
  161, 34, 0, 182, 188, 155, 91, 101, 1, 9,
    0, 0, 0, 0, 35,
};
short cexpyygindex[] = { 0,
  630,
};
short cexpyytable[] = { 32,
    6, 1, 0, 4, 30, 28, 32, 29, 7, 31,
    6, 30, 28, 4, 29, 3, 31, 0, 0, 32,
    6, 0, 0, 8, 30, 3, 0, 0, 0, 31,
    0, 0, 0, 22, 21, 9, 0, 0, 6, 0,
    0, 6, 0, 6, 6, 6, 7, 0, 0, 7,
    0, 7, 7, 7, 0, 0, 0, 0, 6, 0,
    6, 8, 6, 6, 8, 0, 7, 8, 7, 0,
    7, 7, 12, 9, 22, 21, 9, 22, 21, 9,
    0, 8, 13, 8, 0, 8, 8, 0, 0, 0,
   10, 22, 21, 9, 6, 9, 5, 9, 9, 0,
   11, 0, 7, 0, 0, 0, 5, 0, 0, 0,
   12, 14, 0, 12, 0, 0, 12, 8, 0, 0,
   13, 0, 0, 13, 6, 0, 13, 15, 10, 9,
   12, 10, 7, 0, 10, 12, 0, 0, 11, 19,
   13, 11, 0, 0, 11, 13, 0, 8, 10, 14,
    0, 0, 14, 10, 16, 14, 0, 0, 11, 9,
   20, 0, 0, 11, 0, 15, 12, 0, 15, 14,
    0, 15, 0, 0, 14, 0, 13, 0, 0, 0,
   19, 18, 0, 19, 10, 15, 0, 17, 0, 0,
   15, 0, 16, 0, 11, 16, 12, 19, 16, 0,
    0, 20, 19, 0, 20, 14, 13, 0, 0, 0,
    0, 0, 16, 0, 10, 0, 0, 16, 20, 0,
    0, 15, 18, 20, 11, 18, 1, 2, 17, 0,
    0, 17, 17, 18, 0, 14, 0, 2, 0, 18,
    0, 0, 0, 0, 18, 17, 0, 0, 16, 0,
   17, 15, 0, 0, 0, 0, 0, 0, 0, 6,
    6, 6, 6, 6, 6, 6, 6, 7, 7, 7,
    7, 7, 7, 7, 7, 18, 0, 0, 16, 0,
    0, 17, 8, 8, 8, 8, 8, 8, 8, 8,
    0, 0, 0, 0, 9, 9, 9, 9, 9, 9,
    9, 9, 0, 0, 0, 18, 0, 0, 0, 0,
    0, 17, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 12, 12, 0, 0, 0, 0, 12, 12, 0,
    0, 13, 13, 0, 0, 0, 0, 13, 13, 10,
   10, 0, 0, 0, 0, 10, 10, 0, 0, 11,
   11, 0, 32, 25, 0, 11, 11, 30, 28, 0,
   29, 0, 31, 0, 32, 25, 14, 14, 33, 30,
   28, 21, 29, 0, 31, 26, 0, 27, 0, 0,
    0, 0, 15, 15, 0, 0, 0, 26, 0, 27,
   22, 0, 32, 25, 19, 19, 0, 30, 28, 21,
   29, 0, 31, 0, 0, 0, 0, 0, 0, 16,
   16, 0, 0, 54, 0, 26, 20, 27, 22, 0,
    0, 24, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 18, 18, 0, 0,
   32, 25, 17, 17, 0, 30, 28, 21, 29, 24,
   31, 23, 32, 25, 0, 0, 0, 30, 28, 0,
   29, 0, 31, 26, 32, 27, 22, 0, 0, 30,
   28, 0, 29, 0, 31, 26, 0, 27, 22, 23,
   32, 25, 0, 0, 0, 30, 28, 26, 29, 27,
   31, 0, 0, 0, 32, 25, 0, 24, 0, 30,
   28, 0, 29, 26, 31, 27, 32, 0, 0, 24,
    0, 30, 28, 0, 29, 0, 31, 26, 0, 27,
    0, 0, 0, 0, 0, 0, 0, 23, 0, 26,
    0, 27, 0, 0, 0, 0, 0, 24, 0, 23,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 24, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 23, 0, 0,
    0, 0, 0, 0, 13, 14, 15, 16, 17, 18,
    0, 23, 0, 0, 0, 0, 13, 14, 15, 16,
   17, 18, 19, 20, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 13, 14, 15, 16, 17, 18,
   19, 20, 9, 10, 11, 12, 0, 0, 0, 0,
    0, 0, 34, 35, 36, 37, 38, 39, 40, 41,
   42, 43, 44, 45, 46, 47, 48, 49, 50, 51,
   52, 53, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 13, 14, 15, 16, 17, 18, 19, 20,
    0, 0, 0, 55, 13, 14, 15, 16, 17, 18,
   19, 20, 0, 0, 0, 0, 13, 14, 15, 16,
   17, 18, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 13, 14, 15, 16, 17, 18, 19, 0,
    0, 0, 0, 0, 0, 0, 13, 14, 15, 16,
   17, 18, 0, 0, 0, 0, 0, 0, 0, 0,
   15, 16, 17, 18,
};
short cexpyycheck[] = { 37,
    0, 0, -1, 33, 42, 43, 37, 45, 0, 47,
   40, 42, 43, 33, 45, 45, 47, -1, -1, 37,
   40, -1, -1, 0, 42, 45, -1, -1, -1, 47,
   -1, -1, -1, 0, 0, 0, -1, -1, 38, -1,
   -1, 41, -1, 43, 44, 45, 38, -1, -1, 41,
   -1, 43, 44, 45, -1, -1, -1, -1, 58, -1,
   60, 38, 62, 63, 41, -1, 58, 44, 60, -1,
   62, 63, 0, 38, 41, 41, 41, 44, 44, 44,
   -1, 58, 0, 60, -1, 62, 63, -1, -1, -1,
    0, 58, 58, 58, 94, 60, 126, 62, 63, -1,
    0, -1, 94, -1, -1, -1, 126, -1, -1, -1,
   38, 0, -1, 41, -1, -1, 44, 94, -1, -1,
   38, -1, -1, 41, 124, -1, 44, 0, 38, 94,
   58, 41, 124, -1, 44, 63, -1, -1, 38, 0,
   58, 41, -1, -1, 44, 63, -1, 124, 58, 38,
   -1, -1, 41, 63, 0, 44, -1, -1, 58, 124,
    0, -1, -1, 63, -1, 38, 94, -1, 41, 58,
   -1, 44, -1, -1, 63, -1, 94, -1, -1, -1,
   41, 0, -1, 44, 94, 58, -1, 0, -1, -1,
   63, -1, 38, -1, 94, 41, 124, 58, 44, -1,
   -1, 41, 63, -1, 44, 94, 124, -1, -1, -1,
   -1, -1, 58, -1, 124, -1, -1, 63, 58, -1,
   -1, 94, 41, 63, 124, 44, 256, 257, 41, -1,
   -1, 44, 263, 264, -1, 124, -1, 257, -1, 58,
   -1, -1, -1, -1, 63, 58, -1, -1, 94, -1,
   63, 124, -1, -1, -1, -1, -1, -1, -1, 259,
  260, 261, 262, 263, 264, 265, 266, 259, 260, 261,
  262, 263, 264, 265, 266, 94, -1, -1, 124, -1,
   -1, 94, 259, 260, 261, 262, 263, 264, 265, 266,
   -1, -1, -1, -1, 259, 260, 261, 262, 263, 264,
  265, 266, -1, -1, -1, 124, -1, -1, -1, -1,
   -1, 124, -1, -1, -1, -1, -1, -1, -1, -1,
   -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
   -1, 259, 260, -1, -1, -1, -1, 265, 266, -1,
   -1, 259, 260, -1, -1, -1, -1, 265, 266, 259,
  260, -1, -1, -1, -1, 265, 266, -1, -1, 259,
  260, -1, 37, 38, -1, 265, 266, 42, 43, -1,
   45, -1, 47, -1, 37, 38, 265, 266, 41, 42,
   43, 44, 45, -1, 47, 60, -1, 62, -1, -1,
   -1, -1, 265, 266, -1, -1, -1, 60, -1, 62,
   63, -1, 37, 38, 265, 266, -1, 42, 43, 44,
   45, -1, 47, -1, -1, -1, -1, -1, -1, 265,
  266, -1, -1, 58, -1, 60, 266, 62, 63, -1,
   -1, 94, -1, -1, -1, -1, -1, -1, -1, -1,
   -1, -1, -1, -1, -1, -1, 265, 266, -1, -1,
   37, 38, 265, 266, -1, 42, 43, 44, 45, 94,
   47, 124, 37, 38, -1, -1, -1, 42, 43, -1,
   45, -1, 47, 60, 37, 62, 63, -1, -1, 42,
   43, -1, 45, -1, 47, 60, -1, 62, 63, 124,
   37, 38, -1, -1, -1, 42, 43, 60, 45, 62,
   47, -1, -1, -1, 37, 38, -1, 94, -1, 42,
   43, -1, 45, 60, 47, 62, 37, -1, -1, 94,
   -1, 42, 43, -1, 45, -1, 47, 60, -1, 62,
   -1, -1, -1, -1, -1, -1, -1, 124, -1, 60,
   -1, 62, -1, -1, -1, -1, -1, 94, -1, 124,
   -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
   -1, 94, -1, -1, -1, -1, -1, -1, -1, -1,
   -1, -1, -1, -1, -1, -1, -1, 124, -1, -1,
   -1, -1, -1, -1, 259, 260, 261, 262, 263, 264,
   -1, 124, -1, -1, -1, -1, 259, 260, 261, 262,
  263, 264, 265, 266, -1, -1, -1, -1, -1, -1,
   -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
   -1, -1, -1, -1, 259, 260, 261, 262, 263, 264,
  265, 266, 3, 4, 5, 6, -1, -1, -1, -1,
   -1, -1, 13, 14, 15, 16, 17, 18, 19, 20,
   21, 22, 23, 24, 25, 26, 27, 28, 29, 30,
   31, 32, -1, -1, -1, -1, -1, -1, -1, -1,
   -1, -1, 259, 260, 261, 262, 263, 264, 265, 266,
   -1, -1, -1, 54, 259, 260, 261, 262, 263, 264,
  265, 266, -1, -1, -1, -1, 259, 260, 261, 262,
  263, 264, -1, -1, -1, -1, -1, -1, -1, -1,
   -1, -1, 259, 260, 261, 262, 263, 264, 265, -1,
   -1, -1, -1, -1, -1, -1, 259, 260, 261, 262,
  263, 264, -1, -1, -1, -1, -1, -1, -1, -1,
  261, 262, 263, 264,
};
typedef int YYSTYPE;
int cexpyydebug;
int cexpyynerrs;
int cexpyyerrflag;
int cexpyychar;
int cexplastyystate;
short *cexpyyssp;
YYSTYPE *cexpyyvsp;
YYSTYPE cexpyyval;
YYSTYPE cexpyylval;
short cexpyyss[10000];
YYSTYPE cexpyyvs[10000];
int cexpTranslateToken(int tok, int val) {
        if (tok == '\n') return(0);
        if (tok < 256) return(tok);
        switch (tok) {
        case 440: case 441:
                cexpyylval = val;
                return(257);
        case 268: return(259);
        case 269: return(260);
        case 266: return(261);
        case 267: return(262);
        case 264: return(263);
        case 265: return(264);
        case 270: return(265);
        case 271: return(266);
        }
        cexpyylval = 0;
        return(257);
        return(267);
}
int
cexpyyparse()
{
    register int yym, yyn, yystate;
    cexpyynerrs = 0;
    cexpyyerrflag = 0;
    cexpyychar = (-1);
    cexpyyssp = cexpyyss;
    cexpyyvsp = cexpyyvs;
    *cexpyyssp = yystate = 0;
yyloop:
    if ((yyn = cexpyydefred[yystate])) goto yyreduce;
    if (cexpyychar < 0)
    {
                 cexplastyystate = yystate;
        if ((cexpyychar = cexpyylex()) < 0) cexpyychar = 0;
    }
    if ((yyn = cexpyysindex[yystate]) && (yyn += cexpyychar) >= 0 &&
            yyn <= 744 && cexpyycheck[yyn] == cexpyychar)
    {
        if (cexpyyssp >= cexpyyss + 10000 - 1)
        {
            goto yyoverflow;
        }
        *++cexpyyssp = yystate = cexpyytable[yyn];
        *++cexpyyvsp = cexpyylval;
        cexpyychar = (-1);
        if (cexpyyerrflag == 1) styyErrorRecovery();
        if (cexpyyerrflag > 0) --cexpyyerrflag;
        goto yyloop;
    }
    if ((yyn = cexpyyrindex[yystate]) && (yyn += cexpyychar) >= 0 &&
            yyn <= 744 && cexpyycheck[yyn] == cexpyychar)
    {
        yyn = cexpyytable[yyn];
        goto yyreduce;
    }
    if (cexpyyerrflag) goto yyinrecovery;
yynewerror:
    styyerror("syntax error");
yyerrlab:
    ++cexpyynerrs;
yyinrecovery:
    if (cexpyyerrflag < 1)
    {
        cexpyyerrflag = 1;
        for (;;)
        {
            if ((yyn = cexpyysindex[*cexpyyssp]) && (yyn += 256) >= 0 &&
                    yyn <= 744 && cexpyycheck[yyn] == 256)
            {
                if (cexpyyssp >= cexpyyss + 10000 - 1)
                {
                    goto yyoverflow;
                }
                *++cexpyyssp = yystate = cexpyytable[yyn];
                *++cexpyyvsp = cexpyylval;
                goto yyloop;
            }
            else
            {
                if (cexpyyssp <= cexpyyss) goto yyabort;
                --cexpyyssp;
                --cexpyyvsp;
            }
        }
    }
    else
    {
        if (cexpyychar == 0) goto yyabort;
        cexpyychar = (-1);
        goto yyloop;
    }
yyreduce:
    yym = cexpyylen[yyn];
    cexpyyval = cexpyyvsp[1-yym];
    switch (yyn)
    {
case 1:
{ return(cexpyyvsp[0]); }
break;
case 2:
{ return(0); }
break;
case 3:
{cexpyyval = cexpyyvsp[-2] * cexpyyvsp[0];}
break;
case 4:
{
                if (cexpyyvsp[0] == 0) cexpyyval = cexpyyvsp[-2];
                else cexpyyval = cexpyyvsp[-2] / cexpyyvsp[0];
        }
break;
case 5:
{
                if (cexpyyvsp[0] == 0) cexpyyval = cexpyyvsp[-2];
                else cexpyyval = cexpyyvsp[-2] % cexpyyvsp[0];
        }
break;
case 6:
{cexpyyval = cexpyyvsp[-2] + cexpyyvsp[0];}
break;
case 7:
{cexpyyval = cexpyyvsp[-2] - cexpyyvsp[0];}
break;
case 8:
{cexpyyval = cexpyyvsp[-2] << cexpyyvsp[0];}
break;
case 9:
{cexpyyval = cexpyyvsp[-2] >> cexpyyvsp[0];}
break;
case 10:
{cexpyyval = cexpyyvsp[-2] < cexpyyvsp[0];}
break;
case 11:
{cexpyyval = cexpyyvsp[-2] > cexpyyvsp[0];}
break;
case 12:
{cexpyyval = cexpyyvsp[-2] <= cexpyyvsp[0];}
break;
case 13:
{cexpyyval = cexpyyvsp[-2] >= cexpyyvsp[0];}
break;
case 14:
{cexpyyval = cexpyyvsp[-2] == cexpyyvsp[0];}
break;
case 15:
{cexpyyval = cexpyyvsp[-2] != cexpyyvsp[0];}
break;
case 16:
{cexpyyval = cexpyyvsp[-2] & cexpyyvsp[0];}
break;
case 17:
{cexpyyval = cexpyyvsp[-2] ^ cexpyyvsp[0];}
break;
case 18:
{cexpyyval = cexpyyvsp[-2] | cexpyyvsp[0];}
break;
case 19:
{cexpyyval = cexpyyvsp[-2] && cexpyyvsp[0];}
break;
case 20:
{cexpyyval = cexpyyvsp[-2] || cexpyyvsp[0];}
break;
case 21:
{cexpyyval = cexpyyvsp[-4] ? cexpyyvsp[-2] : cexpyyvsp[0];}
break;
case 22:
{cexpyyval = cexpyyvsp[0];}
break;
case 23:
{cexpyyval = -cexpyyvsp[0];}
break;
case 24:
{cexpyyval = !cexpyyvsp[0];}
break;
case 25:
{cexpyyval = ~cexpyyvsp[0];}
break;
case 26:
{cexpyyval = cexpyyvsp[-1];}
break;
case 27:
{cexpyyval= cexpyyvsp[0];}
break;
    }
    cexpyyssp -= yym;
    yystate = *cexpyyssp;
    cexpyyvsp -= yym;
    yym = cexpyylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
        yystate = 7;
        *++cexpyyssp = 7;
        *++cexpyyvsp = cexpyyval;
        if (cexpyychar < 0)
        {
                        cexplastyystate = yystate;
            if ((cexpyychar = cexpyylex()) < 0) cexpyychar = 0;
        }
        if (cexpyychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = cexpyygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= 744 && cexpyycheck[yyn] == yystate)
        yystate = cexpyytable[yyn];
    else
        yystate = cexpyydgoto[yym];
    if (cexpyyssp >= cexpyyss + 10000 - 1)
    {
        goto yyoverflow;
    }
    *++cexpyyssp = yystate;
    *++cexpyyvsp = cexpyyval;
    goto yyloop;
yyoverflow:
    styyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
