
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2002.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#if defined(__WIN32) && (! defined(__WIN32__))
#define __WIN32__ 1
#endif
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#endif
#include "head2.h"
#include "proto.h"
static char * VERSION_NUMBER = "1.5.10je";
static char * FILE_VERSION_NUMBER = "1.5.10je";
static char * PPC_VERSION_MISMATCH = "version-mismatch";
static char * PPC_MULTIPLE_COMPLETIONS = "completions";
static char * PPC_MULTIPLE_COMPLETION_LINE = "cl";
static char * PPC_SINGLE_COMPLETION = "single-completion";
static char * PPC_FQT_COMPLETION = "fqt-completion";
static char * PPC_SYMBOL_LIST = "symbol-list";
static char * PPC_REFACTORING_PRECHECK = "precheck";
static char * PPC_REFACTORING_REPLACEMENT = "replacement";
static char * PPC_REFACTORING_REPLACE = "replace";
static char * PPC_REFACTORING_REPLACE_WITH = "with";
static char * PPC_REFACTORING_CUT_BLOCK = "cut-block";
static char * PPC_REFACTORING_COPY_BLOCK = "copy-block";
static char * PPC_REFACTORING_PASTE_BLOCK = "past-block";
static char * PPC_EXTRACTION_DIALOG = "extraction-dialog";
static char * PPC_DISPLAY_CLASS_TREE = "display-class-tree";
static char * PPC_DISPLAY_RESOLUTION = "display-resolution";
static char * PPC_DISPLAY_OR_UPDATE_BROWSER = "display-or-update-browser";
static char * PPC_SYMBOL_RESOLUTION = "resolution";
static char * PPC_SYMBOL = "symbol";
static char * PPC_VIRTUAL_SYMBOL = "virtual-symbol";
static char * PPC_CLASS = "class";
static char * PPC_REFERENCE_LIST = "reference-list";
static char * PPC_SRC_LINE = "src-line";
static char * PPC_UPDATE_CURRENT_REFERENCE = "update-current-refn";
static char * PPC_NO_PROJECT = "no-project-found";
static char * PPC_SET_PROJECT = "set-project";
static char * PPC_SET_INFO = "set-info";
static char * PPC_WARNING = "warning";
static char * PPC_ERROR = "error";
static char * PPC_FATAL_ERROR = "fatalError";
static char * PPC_INFORMATION = "information";
static char * PPC_BOTTOM_INFORMATION = "bottom-information";
static char * PPC_DEBUG_INFORMATION = "debug-information";
static char * PPC_ASK_CONFIRMATION = "ask-confirmation";
static char * PPC_GOTO = "goto";
static char * PPC_BROWSE_URL = "browse-url";
static char * PPC_FILE_SAVE_AS = "file-save-as";
static char * PPC_MOVE_FILE_AS = "file-move-as";
static char * PPC_FILE_REMOVE = "file-remove";
static char * PPC_MOVE_DIRECTORY = "move-directory";
static char * PPC_INDENT = "indent-block";
static char * PPC_IGNORE = "ignore";
static char * PPC_PROGRESS = "progress";
static char * PPC_UPDATE_REPORT = "update-report";
static char * PPC_AVAILABLE_REFACTORINGS = "available-refactorings";
static char * PPC_SYNCHRO_RECORD = "sync";
static char * PPC_LC_POSITION = "position-lc";
static char * PPC_OFFSET_POSITION = "position-off";
static char * PPC_STRING_VALUE = "string-value";
static char * PPC_INT_VALUE = "int-value";
static char * PPCA_LEN = "len";
static char * PPCA_LINE = "line";
static char * PPCA_COL = "col";
static char * PPCA_OFFSET = "off";
static char * PPCA_VALUE = "val";
static char * PPCA_SELECTED = "selected";
static char * PPCA_BASE = "base";
static char * PPCA_DEF_REFN = "drefn";
static char * PPCA_REFN = "refn";
static char * PPCA_TYPE = "type";
static char * PPCA_MTYPE = "mtype";
static char * PPCA_CONTINUE = "continue";
static char * PPCA_INTERFACE = "interface";
static char * PPCA_INDENT = "indent";
static char * PPCA_TREE_DEPS = "deps";
static char * PPCA_TREE_UP = "up";
static char * PPCA_DEFINITION = "definition";
static int PPCV_BROWSER_TYPE_INFO = 0;
static int PPCV_BROWSER_TYPE_WARNING = 1;
static int PPC_AVR_NO_REFACTORING = 0;
static int PPC_AVR_RENAME_SYMBOL = 1;
static int PPC_AVR_RENAME_CLASS = 2;
static int PPC_AVR_RENAME_PACKAGE = 3;
static int PPC_AVR_ADD_PARAMETER = 4;
static int PPC_AVR_DEL_PARAMETER = 5;
static int PPC_AVR_MOVE_PARAMETER = 6;
static int PPC_AVR_EXTRACT_METHOD = 7;
static int PPC_AVR_EXTRACT_MACRO = 8;
static int PPC_AVR_MOVE_STATIC_FIELD = 9;
static int PPC_AVR_MOVE_STATIC_METHOD = 10;
static int PPC_AVR_MOVE_FIELD = 11;
static int PPC_AVR_PULL_UP_FIELD = 12;
static int PPC_AVR_PULL_UP_METHOD = 13;
static int PPC_AVR_PUSH_DOWN_FIELD = 14;
static int PPC_AVR_PUSH_DOWN_METHOD = 15;
static int PPC_AVR_MOVE_CLASS = 16;
static int PPC_AVR_ENCAPSULATE_FIELD = 17;
static int PPC_AVR_SELF_ENCAPSULATE_FIELD = 18;
static int PPC_AVR_TURN_DYNAMIC_METHOD_TO_STATIC = 19;
static int PPC_AVR_TURN_STATIC_METHOD_TO_DYNAMIC = 20;
static int PPC_AVR_REDUCE_NAMES = 21;
static int PPC_AVR_EXPAND_NAMES = 22;
static int PPC_AVR_SET_MOVE_TARGET = 23;
static int PPC_MAX_AVAILABLE_REFACTORINGS = 24;
#if defined(__APPLE__)
#include <sys/malloc.h>
#else
#include <malloc.h>
#endif
S_editorMemoryBlock *s_editorMemory[32];
S_editorBufferList *s_staticEditorBufferTabTab[100];
S_editorBufferTab s_editorBufferTab;
void editorBufferTabNAInit(struct editorBufferTab *t, int size) {
        register int i;
        t->size = size;
        memset(t->tab, 0, sizeof(S_editorBufferList *)*t->size);
}
void editorBufferTabInit(struct editorBufferTab *t, int size) {
        register int i;
        {t->tab = (S_editorBufferList **) stackMemoryAlloc((size)*sizeof(S_editorBufferList *)); };
        editorBufferTabNAInit(t, size);
}
int editorBufferTabIsMember(
                                        struct editorBufferTab *t,
                                        S_editorBufferList *elem,
                                        int *position,
                                        S_editorBufferList **original
                        ) {
        unsigned posid;
        S_editorBufferList *pp;
        posid = hashFun(elem->f->name);
        posid = posid % t->size;
        *position = posid;
        { if (!(t->tab!=NULL)) internalCheckFail("t->tab!=NULL", "hashlist.tc", 55);};
        for (pp=t->tab[posid]; pp!=NULL; pp=pp->next) {
                if ((strcmp(pp->f->name,elem->f->name)==0)) {
                        *original = pp;
                        return(1);
                }
        }
        *original = NULL;
        return(0);
}
int editorBufferTabNextMember(
                                        S_editorBufferList *elem,
                                        S_editorBufferList **original
                        ) {
        S_editorBufferList *pp;
        { if (!(*original)) internalCheckFail("*original", "hashlist.tc", 77);};
        for (pp= (*original)->next; pp!=NULL; pp=pp->next) {
                if ((strcmp(pp->f->name,elem->f->name)==0)) {
                        *original = pp;
                        return(1);
                }
        }
        *original = NULL;
        return(0);
}
int editorBufferTabMembEqual(
                                        S_editorBufferList *e1,
                                        S_editorBufferList *e2
                        ) {
        { if (!(e1 && e2)) internalCheckFail("e1 && e2", "hashlist.tc", 93);};
        return((strcmp(e1->f->name,e2->f->name)==0));
}
int editorBufferTabDelete(
                                        struct editorBufferTab *t,
                                        S_editorBufferList *elem
                        ) {
        unsigned posid;
        S_editorBufferList **pp;
        posid = hashFun(elem->f->name);
        posid = posid % t->size;
        { if (!(t->tab!=NULL)) internalCheckFail("t->tab!=NULL", "hashlist.tc", 106);};
        for (pp= &(t->tab[posid]); *pp!=NULL; pp= &((*pp)->next)) {
                if ((strcmp((*pp)->f->name,elem->f->name)==0)) {
                        *pp = (*pp)->next;
                        return(1);
                }
        }
        return(0);
}
int editorBufferTabDeleteExact(
                                        struct editorBufferTab *t,
                                        S_editorBufferList *elem
                        ) {
        unsigned posid;
        S_editorBufferList **pp;
        posid = hashFun(elem->f->name);
        posid = posid % t->size;
        { if (!(t->tab!=NULL)) internalCheckFail("t->tab!=NULL", "hashlist.tc", 125);};
        for (pp= &(t->tab[posid]); *pp!=NULL; pp= &((*pp)->next)) {
                if ((*pp) == elem) {
                        *pp = (*pp)->next;
                        return(1);
                }
        }
        return(0);
}
int editorBufferTabDeleteLast(
                                        struct editorBufferTab *t,
                                        S_editorBufferList *elem
                        ) {
        unsigned posid;
        S_editorBufferList **pp, **dd;
        posid = hashFun(elem->f->name);
        posid = posid % t->size;
        { if (!(t->tab!=NULL)) internalCheckFail("t->tab!=NULL", "hashlist.tc", 144);};
        dd = NULL;
        for (pp= &(t->tab[posid]); *pp!=NULL; pp= &((*pp)->next)) {
                if ((strcmp((*pp)->f->name,elem->f->name)==0)) {
                        dd = pp;
                }
        }
        if (dd!=NULL) {
                *dd = (*dd)->next;
                return(1);
        }
        return(0);
}
void editorBufferTabSet (
                                        struct editorBufferTab *t,
                                        S_editorBufferList *elem,
                                        int position
                                ) {
        elem->next = t->tab[position];
    t->tab[position] = elem;
}
void editorBufferTabSetLast (
                                        struct editorBufferTab *t,
                                        S_editorBufferList *elem,
                                        int position
                                ) {
        S_editorBufferList **pp;
        for (pp= &(t->tab[position]); *pp!=NULL; pp= &((*pp)->next)) ;
    *pp = elem;
        elem->next = NULL;
}
void editorBufferTabAdd (
                                        struct editorBufferTab *t,
                                        S_editorBufferList *elem,
                                        int *position
                                ) {
  S_editorBufferList *origin;
  if (! editorBufferTabIsMember(t,elem,position,&origin)) {
        editorBufferTabSet (t,elem,*position);
  }
}
void editorBufferTabFree(struct editorBufferTab *t) {
        { };
}
void editorBufferTabMap(
                                        struct editorBufferTab *t,
                                        void (*fun)(S_editorBufferList *)
                                ) {
        int i;
        S_editorBufferList *pp;
        for(i=0; i<t->size; i++) {
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) (*fun)(pp);
        }
}
void editorBufferTabMap2(
                                        struct editorBufferTab *t,
                                        void (*fun)(S_editorBufferList *, void *),
                                        void *a
                                ) {
        int i;
        S_editorBufferList *pp;
        for(i=0; i<t->size; i++) {
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) (*fun)(pp, a);
        }
}
void editorBufferTabMap3(
                                        struct editorBufferTab *t,
                                        void (*fun)(int)
                                ) {
        int i;
        for(i=0; i<t->size; i++) {
                if (t->tab[i] != NULL) (*fun)(i);
        }
}
void editorBufferTabMap31(
                                        struct editorBufferTab *t,
                                        void (*fun)(int, void *, void *),
                                        void *arg1, void *arg2
                                ) {
        int i;
        for(i=0; i<t->size; i++) {
                if (t->tab[i] != NULL) (*fun)(i,arg1,arg2);
        }
}
void editorBufferTabMap32(
                                        struct editorBufferTab *t,
                                        void (*fun)(int, void *, void *, void *),
                                        void *arg1, void *arg2, void *arg3
                                ) {
        int i;
        for(i=0; i<t->size; i++) {
                if (t->tab[i] != NULL) (*fun)(i,arg1,arg2,arg3);
        }
}
void editorBufferTabMap4(
                                        struct editorBufferTab *t,
                                        void (*fun)(S_editorBufferList *, int),
                                        int a
                                ) {
        int i;
        S_editorBufferList *pp;
        for(i=0; i<t->size; i++) {
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) (*fun)(pp, a);
        }
}
void editorBufferTabMap5(
                                        struct editorBufferTab *t,
                                        void (*fun)(S_editorBufferList *, void *),
                                        void *arg
                                ) {
        int i;
        S_editorBufferList *pp;
        for(i=0; i<t->size; i++) {
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) (*fun)(pp, arg);
        }
}
void editorBufferTabStatistics(
                                        struct editorBufferTab *t,
                                        int *usedIndexes,
                                        int *elements,
                                        int *maxdeep
                                ) {
        int i,ui,el,dp,mdp,mdpi;
        S_editorBufferList *pp;
        ui= el = dp = mdp = 0;
        mdpi = -1;
        for(i=0; i<t->size; i++) {
                if (t->tab[i]!=NULL) ui ++;
                dp = el;
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) {
                        el++;
                }
                if (mdp < el-dp) {mdp = el-dp; mdpi = i;}
        }
        *usedIndexes = ui;
        *elements = el;
        *maxdeep = mdp;
}
void editorInit() {
        s_editorBufferTab.tab = s_staticEditorBufferTabTab;
        editorBufferTabNAInit(&s_editorBufferTab, 100);
}
int statb(char *path, struct stat *statbuf) {
        int res;
        S_editorBuffer *buff;
        buff = editorGetOpenedBuffer(path);
        if (buff!=NULL) {
                if (statbuf!=NULL) {
                        *statbuf = buff->stat;
                }
                return(0);
        }
        res = stat(path, statbuf);
        return(res);
}
static void editorError(int errCode, char *message) {
        error(errCode, message);
}
int editorMarkerLess(S_editorMarker *m1, S_editorMarker *m2) {
        int c;
        if (m1->buffer < m2->buffer) return(1);
        if (m1->buffer > m2->buffer) return(0);
        if (m1->offset < m2->offset) return(1);
        if (m1->offset > m2->offset) return(0);
        return(0);
}
int editorMarkerLessOrEq(S_editorMarker *m1, S_editorMarker *m2) {
        return(! editorMarkerLess(m2, m1));
}
int editorMarkerListLess(S_editorMarkerList *l1, S_editorMarkerList *l2) {
        return(editorMarkerLess(l1->d, l2->d));
}
static void editorAffectMarkerToBuffer(S_editorBuffer *buff, S_editorMarker *marker) {
        marker->buffer = buff;
        marker->next = buff->markers;
        buff->markers = marker;
        marker->previous = NULL;
        if (marker->next!=NULL) marker->next->previous = marker;
}
S_editorMarker *editorCrNewBufferMarker(S_editorBuffer *buff, int offset) {
        S_editorMarker *m;
        { { int n = (int) (((char*)(((1)*sizeof(S_editorMarker))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_editorMarker))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 108);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 108);}; if ((m = (S_editorMarker*) olcxMemoryFreeList[n]) == NULL) { m = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 108);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; m = (S_editorMarker *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) m); }}; while (m==NULL) { freeOldestOlcx(); { int n = (int) (((char*)(((1)*sizeof(S_editorMarker))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_editorMarker))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 108);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 108);}; if ((m = (S_editorMarker*) olcxMemoryFreeList[n]) == NULL) { m = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 108);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; m = (S_editorMarker *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) m); }}; }};
        { (m)->buffer = NULL; (m)->offset = offset; (m)->previous = NULL; (m)->next = NULL;};
        editorAffectMarkerToBuffer(buff, m);
        return(m);
}
static void editorRemoveMarkerFromBufferNoFreeing(S_editorMarker *marker) {
        S_editorMarker **m, *next;
        S_editorBuffer *buff;
        if (marker == NULL) return;
        if (marker->next!=NULL) marker->next->previous = marker->previous;
        if (marker->previous==NULL) {
                marker->buffer->markers = marker->next;
        } else {
                marker->previous->next = marker->next;
        }
}
void editorFreeMarker(S_editorMarker *marker) {
        if (marker == NULL) return;
        editorRemoveMarkerFromBufferNoFreeing(marker);
        { int n = (int) (((char*)((sizeof(S_editorMarker))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)((sizeof(S_editorMarker))))-1) & (STANDARD_ALLIGNEMENT-1)))); * (void **) marker = olcxMemoryFreeList[n]; olcxMemoryFreeList[n] = marker;};
}
static void editorFreeTextSpace(char *space, int index) {
        S_editorMemoryBlock *sp;
        sp = (S_editorMemoryBlock *) space;
        sp->next = s_editorMemory[index];
        s_editorMemory[index] = sp;
}
static void editorFreeBuffer(S_editorBufferList *ll) {
        S_editorMarker *m, *mm;
        if (ll->f->fileName != ll->f->name) {
                { int n = (int) (((char*)((strlen(ll->f->fileName)+1)))+(STANDARD_ALLIGNEMENT-1-((((unsigned)((strlen(ll->f->fileName)+1)))-1) & (STANDARD_ALLIGNEMENT-1)))); * (void **) ll->f->fileName = olcxMemoryFreeList[n]; olcxMemoryFreeList[n] = ll->f->fileName;};
        }
        { int n = (int) (((char*)((strlen(ll->f->name)+1)))+(STANDARD_ALLIGNEMENT-1-((((unsigned)((strlen(ll->f->name)+1)))-1) & (STANDARD_ALLIGNEMENT-1)))); * (void **) ll->f->name = olcxMemoryFreeList[n]; olcxMemoryFreeList[n] = ll->f->name;};
        for(m=ll->f->markers; m!=NULL;) {
                mm = m->next;
                { int n = (int) (((char*)((sizeof(S_editorMarker))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)((sizeof(S_editorMarker))))-1) & (STANDARD_ALLIGNEMENT-1)))); * (void **) m = olcxMemoryFreeList[n]; olcxMemoryFreeList[n] = m;};
                m = mm;
        }
        if (ll->f->b.textLoaded) {
                { if (!(ll->f->a.allocatedBlock[ll->f->a.allocatedSize] == 0x3b)) internalCheckFail("ll->f->a.allocatedBlock[ll->f->a.allocatedSize] == 0x3b", "editor.c", 154);};
                editorFreeTextSpace(ll->f->a.allocatedBlock,ll->f->a.allocatedIndex);
        }
        { int n = (int) (((char*)((sizeof(S_editorBuffer))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)((sizeof(S_editorBuffer))))-1) & (STANDARD_ALLIGNEMENT-1)))); * (void **) ll->f = olcxMemoryFreeList[n]; olcxMemoryFreeList[n] = ll->f;};
        { int n = (int) (((char*)((sizeof(S_editorBufferList))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)((sizeof(S_editorBufferList))))-1) & (STANDARD_ALLIGNEMENT-1)))); * (void **) ll = olcxMemoryFreeList[n]; olcxMemoryFreeList[n] = ll;};
}
static void editorApplyCrLfCrConversion(S_editorBuffer *buff) {
        register char *s, *d, *maxs;
        char *space;
        space = buff->a.text;
        maxs = space + buff->a.bufferSize;
        for(s=d=space; s<maxs; s++) {
                if (*s == '\r') {
                        if (s+1<maxs && *(s+1)=='\n') {
                                s++;
                                *d++ = *s;
                        } else {
                                *d++ = '\n';
                        }
                } else {
                        *d++ = *s;
                }
        }
        buff->a.bufferSize = d - space;
}
static void editorApplyCrLfConversion(S_editorBuffer *buff) {
        register char *s, *d, *maxs;
        char *space;
        space = buff->a.text;
        maxs = space + buff->a.bufferSize;
        for(s=d=space; s<maxs; s++) {
                if (*s == '\r' && s+1<maxs && *(s+1)=='\n') {
                        s++;
                }
                *d++ = *s;
        }
        buff->a.bufferSize = d - space;
}
static void editorApplyCrConversion(S_editorBuffer *buff) {
        register char *s, *d, *maxs;
        char *space;
        space = buff->a.text;
        maxs = space + buff->a.bufferSize;
        for(s=d=space; s<maxs; s++) {
                if (*s == '\r') {
                        *d++ = '\n';
                } else {
                        *d++ = *s;
                }
        }
        buff->a.bufferSize = d - space;
}
static void editorLoadFileIntoBufferText(S_editorBuffer *buff, struct stat *st) {
        register char *s, *d, *maxs;
        char *space, *fname;
        FILE *ff;
        char *bb;
        int n, ss, size;
        fname = buff->fileName;
        space = buff->a.text;
        size = buff->a.bufferSize;
#ifdef __WIN32__
        ff = fopen(fname, "r");
#else
        ff = fopen(fname, "r");
#endif
        if (ff == NULL) {
                fatalError(ERR_CANT_OPEN, fname, 65);
        }
        bb = space; ss = size;
        { if (!(bb != NULL)) internalCheckFail("bb != NULL", "editor.c", 229);};
        do {
                n = fread(bb, 1, ss, ff);
                bb = bb + n;
                ss = ss - n;
        } while (n>0);
        fclose(ff);
        if (ss!=0) {
                buff->a.bufferSize -= ss;
                if (ss < 0) {
                        sprintf(tmpBuff,"File %s: readed %d chars of %d", fname, size-ss, size);
                        editorError(ERR_INTERNAL, tmpBuff);
                }
        }
        if ((s_opt.eolConversion&1)
                && (s_opt.eolConversion & 2)) {
                editorApplyCrLfCrConversion(buff);
        } else if (s_opt.eolConversion & 1) {
                editorApplyCrLfConversion(buff);
        } else if (s_opt.eolConversion & 2) {
                editorApplyCrConversion(buff);
        }
        buff->stat = *st;
        buff->b.textLoaded = 1;
}
static void allocNewEditorBufferTextSpace(S_editorBuffer *ff, int size) {
        int minSize, allocIndex, allocSize;
        char *space;
        minSize = size + 1024 + 16;
        allocIndex = 11; allocSize = 2048;
        for(; allocSize<minSize; ) {
                allocIndex ++;
                allocSize = allocSize << 1;
        }
        space = (char *)s_editorMemory[allocIndex];
        if (space == NULL) {
                space = malloc(allocSize+1);
                if (space == NULL) fatalError(ERR_NO_MEMORY, "global malloc", 65);
                space[allocSize] = 0x3b;
        } else {
                s_editorMemory[allocIndex] = s_editorMemory[allocIndex]->next;
        }
        { (&ff->a)->bufferSize = size; (&ff->a)->text = space+16; (&ff->a)->allocatedFreePrefixSize = 16; (&ff->a)->allocatedBlock = space; (&ff->a)->allocatedIndex = allocIndex; (&ff->a)->allocatedSize = allocSize;};
}
static void fillEmptyEditorBuffer(S_editorBuffer *ff, char *aname, int ftnum,
                                                                  char*afname) {
        { (&ff->b)->textLoaded = 0; (&ff->b)->modified = 0; (&ff->b)->modifiedSinceLastQuasySave = 0;};
        { (&ff->a)->bufferSize = 0; (&ff->a)->text = NULL; (&ff->a)->allocatedFreePrefixSize = 0; (&ff->a)->allocatedBlock = NULL; (&ff->a)->allocatedIndex = 0; (&ff->a)->allocatedSize = 0;};
        { (ff)->name = aname; (ff)->ftnum = ftnum; (ff)->fileName = afname; (ff)->stat = s_noStat; (ff)->markers = NULL; (ff)->a = ff->a; (ff)->b = ff->b;};
}
static S_editorBuffer *editorCrNewBuffer(char *name, char *fileName, struct stat *st) {
        int minSize, allocIndex, allocSize, ii;
        char *space;
        char *aname, *nname, *afname, *nfileName;
        S_editorBuffer *ff;
        S_editorBufferList *ffl;
        int ftnum;
        nname = normalizeFileName(name, s_cwd);
        { { int n = (int) (((char*)(((strlen(nname)+1)*sizeof(char))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((strlen(nname)+1)*sizeof(char))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 298);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 298);}; if ((aname = (char*) olcxMemoryFreeList[n]) == NULL) { aname = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 298);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; aname = (char *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) aname); }}; while (aname==NULL) { freeOldestOlcx(); { int n = (int) (((char*)(((strlen(nname)+1)*sizeof(char))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((strlen(nname)+1)*sizeof(char))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 298);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 298);}; if ((aname = (char*) olcxMemoryFreeList[n]) == NULL) { aname = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 298);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; aname = (char *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) aname); }}; }};
        strcpy(aname, nname);
        nfileName = normalizeFileName(fileName, s_cwd);
        if (strcmp(nfileName, aname)==0) {
                afname = aname;
        } else {
                { { int n = (int) (((char*)(((strlen(nfileName)+1)*sizeof(char))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((strlen(nfileName)+1)*sizeof(char))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 304);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 304);}; if ((afname = (char*) olcxMemoryFreeList[n]) == NULL) { afname = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 304);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; afname = (char *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) afname); }}; while (afname==NULL) { freeOldestOlcx(); { int n = (int) (((char*)(((strlen(nfileName)+1)*sizeof(char))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((strlen(nfileName)+1)*sizeof(char))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 304);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 304);}; if ((afname = (char*) olcxMemoryFreeList[n]) == NULL) { afname = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 304);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; afname = (char *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) afname); }}; }};
                strcpy(afname, nfileName);
        }
        { { int n = (int) (((char*)(((1)*sizeof(S_editorBuffer))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_editorBuffer))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 307);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 307);}; if ((ff = (S_editorBuffer*) olcxMemoryFreeList[n]) == NULL) { ff = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 307);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; ff = (S_editorBuffer *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) ff); }}; while (ff==NULL) { freeOldestOlcx(); { int n = (int) (((char*)(((1)*sizeof(S_editorBuffer))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_editorBuffer))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 307);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 307);}; if ((ff = (S_editorBuffer*) olcxMemoryFreeList[n]) == NULL) { ff = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 307);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; ff = (S_editorBuffer *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) ff); }}; }};
        addFileTabItem(aname, &ftnum);
        fillEmptyEditorBuffer(ff, aname, ftnum, afname);
        ff->stat = *st;
        { { int n = (int) (((char*)(((1)*sizeof(S_editorBufferList))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_editorBufferList))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 312);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 312);}; if ((ffl = (S_editorBufferList*) olcxMemoryFreeList[n]) == NULL) { ffl = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 312);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; ffl = (S_editorBufferList *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) ffl); }}; while (ffl==NULL) { freeOldestOlcx(); { int n = (int) (((char*)(((1)*sizeof(S_editorBufferList))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_editorBufferList))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 312);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 312);}; if ((ffl = (S_editorBufferList*) olcxMemoryFreeList[n]) == NULL) { ffl = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 312);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; ffl = (S_editorBufferList *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) ffl); }}; }};
        { (ffl)->f = ff; (ffl)->next = NULL;};
        editorBufferTabAdd(&s_editorBufferTab, ffl, &ii);
        return(ff);
}
static void editorSetBufferModifiedFlag(S_editorBuffer *buff) {
        buff->b.modified = 1;
        buff->b.modifiedSinceLastQuasySave = 1;
}
S_editorBuffer *editorGetOpenedBuffer(char *name) {
        S_editorBufferBits ddb;
        S_editorBuffer dd;
        S_editorBufferList ddl, *memb;
        int ii;
        fillEmptyEditorBuffer(&dd, name, 0, name);
        { (&ddl)->f = &dd; (&ddl)->next = NULL;};
        if (editorBufferTabIsMember(&s_editorBufferTab, &ddl, &ii, &memb)) {
                return(memb->f);
        }
        return(NULL);
}
S_editorBuffer *editorGetOpenedAndLoadedBuffer(char *name) {
        S_editorBuffer *res;
        res = editorGetOpenedBuffer(name);
        if (res!=NULL && res->b.textLoaded) return(res);
        return(NULL);
}
void editorRenameBuffer(S_editorBuffer *buff, char *nName, S_editorUndo **undo) {
        char newName[MAX_FILE_NAME_SIZE];
        int fti, ii, mem, deleted;
        S_editorBufferBits ddb;
        S_editorBuffer dd, *removed;
        S_editorBufferList ddl, *memb, *memb2;
        S_editorUndo *uu;
        char *oldName;
        strcpy(newName, normalizeFileName(nName, s_cwd));
        fillEmptyEditorBuffer(&dd, buff->name, 0, buff->name);
        { (&ddl)->f = &dd; (&ddl)->next = NULL;};
        mem = editorBufferTabIsMember(&s_editorBufferTab, &ddl, &ii, &memb);
        if (! mem) {
                sprintf(tmpBuff, "Trying to rename non existing buffer %s", buff->name);
                error(ERR_INTERNAL, tmpBuff);
                return;
        }
        { if (!(memb->f == buff)) internalCheckFail("memb->f == buff", "editor.c", 363);};
        deleted = editorBufferTabDeleteExact(&s_editorBufferTab, memb);
        { if (!(deleted)) internalCheckFail("deleted", "editor.c", 365);};
        oldName = buff->name;
        { { int n = (int) (((char*)(((strlen(newName)+1)*sizeof(char))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((strlen(newName)+1)*sizeof(char))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 367);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 367);}; if ((buff->name = (char*) olcxMemoryFreeList[n]) == NULL) { buff->name = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 367);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; buff->name = (char *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) buff->name); }}; while (buff->name==NULL) { freeOldestOlcx(); { int n = (int) (((char*)(((strlen(newName)+1)*sizeof(char))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((strlen(newName)+1)*sizeof(char))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 367);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 367);}; if ((buff->name = (char*) olcxMemoryFreeList[n]) == NULL) { buff->name = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 367);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; buff->name = (char *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) buff->name); }}; }};
        strcpy(buff->name, newName);
        addFileTabItem(newName, &fti);
        s_fileTab.tab[fti]->b.commandLineEntered = s_fileTab.tab[buff->ftnum]->b.commandLineEntered;
        buff->ftnum = fti;
        { (memb)->f = buff; (memb)->next = NULL;};
        if (editorBufferTabIsMember(&s_editorBufferTab, memb, &ii, &memb2)) {
                editorBufferTabDeleteExact(&s_editorBufferTab, memb2);
                editorFreeBuffer(memb2);
        }
        editorBufferTabAdd(&s_editorBufferTab, memb, &ii);
        if (undo!=NULL) {
                { { int n = (int) (((char*)(((1)*sizeof(S_editorUndo))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_editorUndo))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 383);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 383);}; if ((uu = (S_editorUndo*) olcxMemoryFreeList[n]) == NULL) { uu = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 383);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; uu = (S_editorUndo *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) uu); }}; while (uu==NULL) { freeOldestOlcx(); { int n = (int) (((char*)(((1)*sizeof(S_editorUndo))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_editorUndo))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 383);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 383);}; if ((uu = (S_editorUndo*) olcxMemoryFreeList[n]) == NULL) { uu = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 383);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; uu = (S_editorUndo *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) uu); }}; }};
                { (uu)->buffer = buff; (uu)->operation = UNDO_RENAME_BUFFER; { (&((&(uu)->u)->rename))->name = oldName;}; (uu)->next = *undo;};
                *undo = uu;
        }
        editorSetBufferModifiedFlag(buff);
        removed = editorCrNewBuffer(oldName, oldName, &buff->stat);
        allocNewEditorBufferTextSpace(removed, 0);
        removed->b.textLoaded = 1;
        editorSetBufferModifiedFlag(removed);
}
S_editorBuffer *editorOpenBufferNoFileLoad(char *name, char *fileName) {
        S_editorBuffer *res;
        struct stat st;
        res = editorGetOpenedBuffer(name);
        if (res != NULL) {
                return(res);
        }
        stat(fileName, &st);
        res = editorCrNewBuffer(name, fileName, &st);
        return(res);
}
S_editorBuffer *editorFindFile(char *name) {
        int size;
        struct stat st;
        S_editorBuffer *res;
        res = editorGetOpenedAndLoadedBuffer(name);
        if (res==NULL) {
                res = editorGetOpenedBuffer(name);
                if (res == NULL) {
                        if (stat(name, &st)==0 && (st.st_mode & S_IFMT)!=S_IFDIR) {
                                res = editorCrNewBuffer(name, name, &st);
                        }
                }
                if (res != NULL && stat(res->fileName, &st)==0 && (st.st_mode & S_IFMT)!=S_IFDIR) {
                        size = st.st_size;
                        allocNewEditorBufferTextSpace(res, size);
                        editorLoadFileIntoBufferText(res, &st);
                } else {
                        return(NULL);
                }
        }
        return(res);
}
void editorReplaceString(S_editorBuffer *buff, int position, int delsize,
                                                 char *str, int strlength, S_editorUndo **undo) {
        int nsize, oldsize, index, undosize, pattractor;
        char *text, *space, *undotext;
        S_editorBuffer *nb;
        S_editorMarker *m;
        S_editorUndo *uu;
        { if (!(position >=0 && position <= buff->a.bufferSize)) internalCheckFail("position >=0 && position <= buff->a.bufferSize", "editor.c", 444);};
        { if (!(delsize >= 0)) internalCheckFail("delsize >= 0", "editor.c", 445);};
        oldsize = buff->a.bufferSize;
        if (delsize+position > oldsize) {
                delsize = oldsize - position;
                if (s_opt.debug) { if (!(0)) internalCheckFail("0", "editor.c", 451);};
        }
        nsize = oldsize + strlength - delsize;
        if (nsize >= buff->a.allocatedSize) {
                text = buff->a.text;
                space = buff->a.allocatedBlock; index = buff->a.allocatedIndex;
                allocNewEditorBufferTextSpace(buff, nsize);
                strcpy(buff->a.text, text);
                buff->a.bufferSize = oldsize;
                editorFreeTextSpace(space, index);
        }
        { if (!(nsize < buff->a.allocatedSize)) internalCheckFail("nsize < buff->a.allocatedSize", "editor.c", 466);};
        if (undo!=NULL) {
                undosize = strlength;
                { if (!(delsize >= 0)) internalCheckFail("delsize >= 0", "editor.c", 470);};
                { { int n = (int) (((char*)(((delsize+1)*sizeof(char))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((delsize+1)*sizeof(char))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 472);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 472);}; if ((undotext = (char*) olcxMemoryFreeList[n]) == NULL) { undotext = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 472);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; undotext = (char *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) undotext); }}; while (undotext==NULL) { freeOldestOlcx(); { int n = (int) (((char*)(((delsize+1)*sizeof(char))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((delsize+1)*sizeof(char))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 472);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 472);}; if ((undotext = (char*) olcxMemoryFreeList[n]) == NULL) { undotext = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 472);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; undotext = (char *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) undotext); }}; }};
                strncpy(undotext, buff->a.text+position, delsize);
                undotext[delsize]=0;
                { { int n = (int) (((char*)(((1)*sizeof(S_editorUndo))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_editorUndo))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 475);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 475);}; if ((uu = (S_editorUndo*) olcxMemoryFreeList[n]) == NULL) { uu = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 475);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; uu = (S_editorUndo *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) uu); }}; while (uu==NULL) { freeOldestOlcx(); { int n = (int) (((char*)(((1)*sizeof(S_editorUndo))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_editorUndo))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 475);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 475);}; if ((uu = (S_editorUndo*) olcxMemoryFreeList[n]) == NULL) { uu = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 475);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; uu = (S_editorUndo *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) uu); }}; }};
                { (uu)->buffer = buff; (uu)->operation = UNDO_REPLACE_STRING; { (&((&(uu)->u)->replace))->offset = position; (&((&(uu)->u)->replace))->size = undosize; (&((&(uu)->u)->replace))->strlen = delsize; (&((&(uu)->u)->replace))->str = undotext;}; (uu)->next = *undo;};
                *undo = uu;
        }
        memmove(buff->a.text+position+strlength, buff->a.text+position+delsize,
                        buff->a.bufferSize - position - delsize);
        strncpy(buff->a.text+position, str, strlength);
        buff->a.bufferSize = buff->a.bufferSize - delsize + strlength;
        if (delsize > strlength) {
                if (strlength > 0) pattractor = position + strlength - 1;
                else pattractor = position + strlength;
                for(m=buff->markers; m!=NULL; m=m->next) {
                        if (m->offset >= position + strlength) {
                                if (m->offset < position+delsize) {
                                        m->offset = pattractor;
                                } else {
                                        m->offset = m->offset - delsize + strlength;
                                }
                        }
                }
        } else {
                for(m=buff->markers; m!=NULL; m=m->next) {
                        if (m->offset >= position + delsize) {
                                m->offset = m->offset - delsize + strlength;
                        }
                }
        }
        editorSetBufferModifiedFlag(buff);
}
void editorMoveBlock(S_editorMarker *dest, S_editorMarker *src, int size,
                                         S_editorUndo **undo) {
        S_editorMarker *mmoved, *tmp, **mmm, *mm;
        S_editorBuffer *sb, *db;
        S_editorUndo *uu;
        int off1, off2, offd, undodoffset;
        mmoved = NULL;
        { if (!(size>=0)) internalCheckFail("size>=0", "editor.c", 517);};
        if (dest->buffer == src->buffer
                && dest->offset > src->offset
                && dest->offset < src->offset+size) {
                error(ERR_INTERNAL, "[editor] moving block to its original place");
                return;
        }
        sb = src->buffer;
        db = dest->buffer;
        offd = dest->offset;
        off1 = src->offset;
        off2 = off1+size;
        { if (!(off1 <= off2)) internalCheckFail("off1 <= off2", "editor.c", 530);};
        editorReplaceString(db, offd, 0, sb->a.text+off1, off2-off1, NULL);
        off1 = src->offset;
        off2 = off1+size;
        editorReplaceString(db, offd, off2-off1, sb->a.text+off1, off2-off1, NULL);
        undodoffset = src->offset;
        { if (!(off1 == src->offset)) internalCheckFail("off1 == src->offset", "editor.c", 541);};
        { if (!(off2 == off1+size)) internalCheckFail("off2 == off1+size", "editor.c", 542);};
        mm = sb->markers;
        while (mm!=NULL) {
                tmp = mm->next;
                if (mm->offset>=off1 && mm->offset<off2) {
                        editorRemoveMarkerFromBufferNoFreeing(mm);
                        mm->offset = offd + (mm->offset-off1);
                        editorAffectMarkerToBuffer(db, mm);
                }
                mm = tmp;
        }
        editorReplaceString(sb, off1, off2-off1, sb->a.text+off1, 0, NULL);
        editorSetBufferModifiedFlag(sb);
        editorSetBufferModifiedFlag(db);
        if (undo!=NULL) {
                { { int n = (int) (((char*)(((1)*sizeof(S_editorUndo))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_editorUndo))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 560);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 560);}; if ((uu = (S_editorUndo*) olcxMemoryFreeList[n]) == NULL) { uu = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 560);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; uu = (S_editorUndo *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) uu); }}; while (uu==NULL) { freeOldestOlcx(); { int n = (int) (((char*)(((1)*sizeof(S_editorUndo))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_editorUndo))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 560);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 560);}; if ((uu = (S_editorUndo*) olcxMemoryFreeList[n]) == NULL) { uu = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 560);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; uu = (S_editorUndo *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) uu); }}; }};
                { (uu)->buffer = db; (uu)->operation = UNDO_MOVE_BLOCK; { (&((&(uu)->u)->moveBlock))->offset = src->offset; (&((&(uu)->u)->moveBlock))->size = off2-off1; (&((&(uu)->u)->moveBlock))->dbuffer = sb; (&((&(uu)->u)->moveBlock))->doffset = undodoffset;}; (uu)->next = *undo;};
                *undo = uu;
        }
}
void editorDumpBuffer(S_editorBuffer *buff) {
        int i;
        for(i=0; i<buff->a.bufferSize; i++) {
                putc(buff->a.text[i], dumpOut);
        }
}
void editorDumpBuffers() {
        int i;
        S_editorBufferList *ll;
        fprintf(dumpOut,"[editorDumpBuffers] start\n");
        for(i=0; i<s_editorBufferTab.size; i++) {
                for(ll=s_editorBufferTab.tab[i]; ll!=NULL; ll=ll->next) {
                        fprintf(dumpOut,"%d : %s==%s, %d\n", i, ll->f->name, ll->f->fileName,
                                        ll->f->b.textLoaded);
                }
        }
        fprintf(dumpOut,"[editorDumpBuffers] end\n");
}
static void editorQuasySaveBuffer(S_editorBuffer *buff) {
        buff->b.modifiedSinceLastQuasySave = 0;
        buff->stat.st_mtime = time(NULL);
        { if (!(s_fileTab.tab[buff->ftnum])) internalCheckFail("s_fileTab.tab[buff->ftnum]", "editor.c", 591);};
        s_fileTab.tab[buff->ftnum]->lastModif = buff->stat.st_mtime;
}
void editorQuasySaveModifiedBuffers() {
        int i, saving;
        static time_t lastQuazySaveTime = 0;
        time_t timeNull;
        S_editorBufferList *ll;
        saving = 0;
        for(i=0; i<s_editorBufferTab.size; i++) {
                for(ll=s_editorBufferTab.tab[i]; ll!=NULL; ll=ll->next) {
                        if (ll->f->b.modifiedSinceLastQuasySave) {
                                saving = 1;
                                goto cont;
                        }
                }
        }
 cont:
        if (saving) {
                timeNull = time(NULL);
                if (lastQuazySaveTime > timeNull+5) {
                        fatalError(ERR_INTERNAL, "last save in the future, travelling in time?", 65);
                } else if (lastQuazySaveTime >= timeNull) {
                        sleep(1+lastQuazySaveTime-timeNull);
                }
        }
        for(i=0; i<s_editorBufferTab.size; i++) {
                for(ll=s_editorBufferTab.tab[i]; ll!=NULL; ll=ll->next) {
                        if (ll->f->b.modifiedSinceLastQuasySave) {
                                editorQuasySaveBuffer(ll->f);
                        }
                }
        }
        lastQuazySaveTime = time(NULL);
}
void editorLoadAllOpenedBufferFiles() {
        int i, size;
        S_editorBufferList *ll,*nn;
        struct stat st;
        for(i=0; i<s_editorBufferTab.size; i++) {
                for(ll=s_editorBufferTab.tab[i]; ll!=NULL; ll=ll->next) {
                        if (!ll->f->b.textLoaded) {
                                if (stat(ll->f->fileName, &st)==0) {
                                        size = st.st_size;
                                        allocNewEditorBufferTextSpace(ll->f, size);
                                        editorLoadFileIntoBufferText(ll->f, &st);
                                }
                        }
                }
        }
}
S_editorMarker *editorCrNewMarkerForPosition(S_position *pos) {
        S_editorBuffer *buf;
        S_editorMarker *mm;
        if (pos->file==s_noneFileIndex || pos->file<0) {
                error(ERR_INTERNAL, "[editor] creating marker for nonexistant position");
        }
        buf = editorFindFile(s_fileTab.tab[pos->file]->name);
        mm = editorCrNewBufferMarker(buf, 0);
        editorMoveMarkerToLineCol(mm, pos->line, pos->coll);
        return(mm);
}
int editorRunWithMarkerUntil(S_editorMarker *m, int (*until)(int), int step) {
        int offset, max;
        char *text;
        { if (!(step==-1 || step==1)) internalCheckFail("step==-1 || step==1", "editor.c", 664);};
        offset = m->offset;
        max = m->buffer->a.bufferSize;
        text = m->buffer->a.text;
        while (offset>=0 && offset<max && (*until)(text[offset])==0) offset += step;
        m->offset = offset;
        if (offset<0) {
                m->offset = 0;
                return(0);
        }
        if (offset>=max) {
                m->offset = max-1;
                return(0);
        }
        return(1);
}
int editorCountLinesBetweenMarkers(S_editorMarker *m1, S_editorMarker *m2) {
        int i, max, count;
        char *text;
        { if (!(m1->buffer == m2->buffer)) internalCheckFail("m1->buffer == m2->buffer", "editor.c", 684);};
        { if (!(m1->offset <= m2->offset)) internalCheckFail("m1->offset <= m2->offset", "editor.c", 685);};
        text = m1->buffer->a.text;
        max = m2->offset;
        count = 0;
        for(i=m1->offset; i<max; i++) {
                if (text[i]=='\n') count ++;
        }
        return(count);
}
static int isNewLine(int c) {return(c=='\n');}
int editorMoveMarkerToNewline(S_editorMarker *m, int direction) {
        return(editorRunWithMarkerUntil(m, isNewLine, direction));
}
static int isNonBlank(int c) {return(! isspace(c));}
int editorMoveMarkerToNonBlank(S_editorMarker *m, int direction) {
        return(editorRunWithMarkerUntil(m, isNonBlank, direction));
}
void editorMoveMarkerToLineCol(S_editorMarker *m, int line, int col) {
        register char *s, *smax;
        register int ln;
        S_editorBuffer *buff;
        int c;
        { if (!(m)) internalCheckFail("m", "editor.c", 710);};
        buff = m->buffer;
        s = buff->a.text;
        smax = s + buff->a.bufferSize;
        ln = 1;
        if (line > 1) {
                for(; s<smax; s++) {
                        if (*s == '\n') {
                                ln ++;
                                if (ln == line) break;
                        }
                }
                if (s < smax) s++;
        }
        c = 0;
        for(; s<smax && c<col; s++,c++) {
                if (*s == '\n') break;
        }
        m->offset = s - buff->a.text;
        { if (!(m->offset>=0 && m->offset<=buff->a.bufferSize)) internalCheckFail("m->offset>=0 && m->offset<=buff->a.bufferSize", "editor.c", 729);};
}
S_editorMarkerList *editorReferencesToMarkers(S_reference *refs, int (*filter)(S_reference *)) {
        S_reference *r;
        S_editorMarker *m;
        S_editorMarkerList *res, *rrr;
        int line, col, file, maxoffset;
        register char *s, *smax;
        register int ln, c;
        S_editorBuffer *buff;
        res = NULL;
        r = refs;
        while (r!=NULL) {
                while (r!=NULL && ! filter(r)) r = r->next;
                if (r != NULL) {
                        file = r->p.file;
                        line = r->p.line;
                        col = r->p.coll;
                        buff = editorFindFile(s_fileTab.tab[file]->name);
                        if (buff==NULL) {
                                error(ERR_CANT_OPEN, s_fileTab.tab[file]->name);
                                while (r!=NULL && file == r->p.file) r = r->next;
                        } else {
                                s = buff->a.text;
                                smax = s + buff->a.bufferSize;
                                maxoffset = buff->a.bufferSize - 1;
                                if (maxoffset < 0) maxoffset = 0;
                                ln = 1; c = 0;
                                for(; s<smax; s++, c++) {
                                        if (ln==line && c==col) {
                                                m = editorCrNewBufferMarker(buff, s - buff->a.text);
                                                { { int n = (int) (((char*)(((1)*sizeof(S_editorMarkerList))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_editorMarkerList))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 761);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 761);}; if ((rrr = (S_editorMarkerList*) olcxMemoryFreeList[n]) == NULL) { rrr = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 761);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; rrr = (S_editorMarkerList *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) rrr); }}; while (rrr==NULL) { freeOldestOlcx(); { int n = (int) (((char*)(((1)*sizeof(S_editorMarkerList))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_editorMarkerList))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 761);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 761);}; if ((rrr = (S_editorMarkerList*) olcxMemoryFreeList[n]) == NULL) { rrr = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 761);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; rrr = (S_editorMarkerList *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) rrr); }}; }};
                                                { (rrr)->d = m; (rrr)->usage = r->usage; (rrr)->next = res;};
                                                res = rrr;
                                                r = r->next;
                                                while (r!=NULL && ! filter(r)) r = r->next;
                                                if (r==NULL || file != r->p.file) break;
                                                line = r->p.line;
                                                col = r->p.coll;
                                        }
                                        if (*s=='\n') {ln++; c = -1;}
                                }
                                while (r!=NULL && file == r->p.file) {
                                        m = editorCrNewBufferMarker(buff, maxoffset);
                                        { { int n = (int) (((char*)(((1)*sizeof(S_editorMarkerList))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_editorMarkerList))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 775);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 775);}; if ((rrr = (S_editorMarkerList*) olcxMemoryFreeList[n]) == NULL) { rrr = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 775);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; rrr = (S_editorMarkerList *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) rrr); }}; while (rrr==NULL) { freeOldestOlcx(); { int n = (int) (((char*)(((1)*sizeof(S_editorMarkerList))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_editorMarkerList))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 775);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 775);}; if ((rrr = (S_editorMarkerList*) olcxMemoryFreeList[n]) == NULL) { rrr = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 775);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; rrr = (S_editorMarkerList *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) rrr); }}; }};
                                        { (rrr)->d = m; (rrr)->usage = r->usage; (rrr)->next = res;};
                                        res = rrr;
                                        r = r->next;
                                        while (r!=NULL && ! filter(r)) r = r->next;
                                }
                        }
                }
        }
        { register S_editorMarkerList *list,*tmp,*revlist; list = res; revlist = NULL; while (list!=NULL) { tmp = list->next; list->next = revlist; revlist = list; list = tmp; } res = revlist;};
        return(res);
}
S_reference *editorMarkersToReferences(S_editorMarkerList **mms) {
        S_editorMarkerList *mm;
        S_editorBuffer *buf;
        char *s, *smax, *off;
        int ln, c;
        S_reference *res, *rr;
        { S_editorMarkerList *_macrores; _macrores = (*mms); { S_editorMarkerList *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (editorMarkerListLess(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (*mms) = _macrores;};
        res = NULL;
        mm = *mms;
        while (mm!=NULL) {
                buf = mm->d->buffer;
                s = buf->a.text;
                smax = s + buf->a.bufferSize;
                off = buf->a.text + mm->d->offset;
                ln = 1; c = 0;
                for( ; s<smax; s++, c++) {
                        if (s == off) {
                                { { int n = (int) (((char*)(((1)*sizeof(S_reference))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_reference))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 807);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 807);}; if ((rr = (S_reference*) olcxMemoryFreeList[n]) == NULL) { rr = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 807);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; rr = (S_reference *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) rr); }}; while (rr==NULL) { freeOldestOlcx(); { int n = (int) (((char*)(((1)*sizeof(S_reference))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_reference))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 807);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 807);}; if ((rr = (S_reference*) olcxMemoryFreeList[n]) == NULL) { rr = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 807);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; rr = (S_reference *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) rr); }}; }};
                                { (rr)->usage = UsageUsed; (rr)->p.file = buf->ftnum; (rr)->p.line = ln; (rr)->p.coll = c; (rr)->next = res;};
                                res = rr;
                                mm = mm->next;
                                if (mm==NULL || mm->d->buffer != buf) break;
                                off = buf->a.text + mm->d->offset;
                        }
                        if (*s=='\n') {ln++; c = -1;}
                }
                while (mm!=NULL && mm->d->buffer==buf) {
                        { { int n = (int) (((char*)(((1)*sizeof(S_reference))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_reference))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 817);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 817);}; if ((rr = (S_reference*) olcxMemoryFreeList[n]) == NULL) { rr = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 817);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; rr = (S_reference *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) rr); }}; while (rr==NULL) { freeOldestOlcx(); { int n = (int) (((char*)(((1)*sizeof(S_reference))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_reference))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 817);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 817);}; if ((rr = (S_reference*) olcxMemoryFreeList[n]) == NULL) { rr = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 817);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; rr = (S_reference *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) rr); }}; }};
                        { (rr)->usage = UsageUsed; (rr)->p.file = buf->ftnum; (rr)->p.line = ln; (rr)->p.coll = 0; (rr)->next = res;};
                        res = rr;
                        mm = mm->next;
                }
        }
        { S_reference *_macrores; _macrores = (res); { S_reference *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (olcxReferenceInternalLessFunction(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (res) = _macrores;};
        return(res);
}
void editorFreeMarkerListNotMarkers(S_editorMarkerList *occs) {
        S_editorMarkerList *o, *next;
        for(o=occs; o!=NULL; ) {
                next = o->next;
                { int n = (int) (((char*)((sizeof(S_editorMarkerList))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)((sizeof(S_editorMarkerList))))-1) & (STANDARD_ALLIGNEMENT-1)))); * (void **) o = olcxMemoryFreeList[n]; olcxMemoryFreeList[n] = o;};
                o = next;
        }
}
void editorFreeMarkersAndMarkerList(S_editorMarkerList *occs) {
        S_editorMarkerList *o, *next;
        for(o=occs; o!=NULL; ) {
                editorFreeMarker(o->d);
                next = o->next;
                { int n = (int) (((char*)((sizeof(S_editorMarkerList))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)((sizeof(S_editorMarkerList))))-1) & (STANDARD_ALLIGNEMENT-1)))); * (void **) o = olcxMemoryFreeList[n]; olcxMemoryFreeList[n] = o;};
                o = next;
        }
}
void editorDumpMarkerList(S_editorMarkerList *mml) {
        S_editorMarkerList *mm;
        fprintf(dumpOut, "[[dumping editor markers]]\n");
        for(mm=mml; mm!=NULL; mm=mm->next) {
                if (mm->d == NULL) {
                        fprintf(dumpOut, "[null]\n");
                } else {
                        fprintf(dumpOut, "[%d(%s):%d] file=%d\n", mm->d->buffer, mm->d->buffer->name, mm->d->offset, s_fileTab.tab[mm->d->buffer->ftnum]);
                }
        }
        fprintf(dumpOut, "\n\n");
}
void editorMarkersDifferences(S_editorMarkerList **list1, S_editorMarkerList **list2,
                                                          S_editorMarkerList **diff1, S_editorMarkerList **diff2) {
        S_editorMarkerList *l1, *l2, *ll;
        S_editorMarker *m;
        { S_editorMarkerList *_macrores; _macrores = (*list1); { S_editorMarkerList *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (editorMarkerListLess(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (*list1) = _macrores;};
        { S_editorMarkerList *_macrores; _macrores = (*list2); { S_editorMarkerList *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (editorMarkerListLess(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (*list2) = _macrores;};
        *diff1 = *diff2 = NULL;
        for(l1 = *list1, l2 = *list2; l1!=NULL && l2!=NULL; ) {
                if (editorMarkerListLess(l1, l2)) {
                        m = editorCrNewBufferMarker(l1->d->buffer, l1->d->offset);
                        { { int n = (int) (((char*)(((1)*sizeof(S_editorMarkerList))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_editorMarkerList))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 869);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 869);}; if ((ll = (S_editorMarkerList*) olcxMemoryFreeList[n]) == NULL) { ll = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 869);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; ll = (S_editorMarkerList *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) ll); }}; while (ll==NULL) { freeOldestOlcx(); { int n = (int) (((char*)(((1)*sizeof(S_editorMarkerList))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_editorMarkerList))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 869);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 869);}; if ((ll = (S_editorMarkerList*) olcxMemoryFreeList[n]) == NULL) { ll = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 869);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; ll = (S_editorMarkerList *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) ll); }}; }};
                        { (ll)->d = m; (ll)->usage = l1->usage; (ll)->next = *diff1;};
                        *diff1 = ll;
                        l1 = l1->next;
                } else if (editorMarkerListLess(l2, l1)) {
                        m = editorCrNewBufferMarker(l2->d->buffer, l2->d->offset);
                        { { int n = (int) (((char*)(((1)*sizeof(S_editorMarkerList))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_editorMarkerList))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 875);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 875);}; if ((ll = (S_editorMarkerList*) olcxMemoryFreeList[n]) == NULL) { ll = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 875);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; ll = (S_editorMarkerList *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) ll); }}; while (ll==NULL) { freeOldestOlcx(); { int n = (int) (((char*)(((1)*sizeof(S_editorMarkerList))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_editorMarkerList))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 875);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 875);}; if ((ll = (S_editorMarkerList*) olcxMemoryFreeList[n]) == NULL) { ll = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 875);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; ll = (S_editorMarkerList *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) ll); }}; }};
                        { (ll)->d = m; (ll)->usage = l2->usage; (ll)->next = *diff2;};
                        *diff2 = ll;
                        l2 = l2->next;
                } else {
                        l1 = l1->next; l2 = l2->next;
                }
        }
        while (l1 != NULL) {
                m = editorCrNewBufferMarker(l1->d->buffer, l1->d->offset);
                { { int n = (int) (((char*)(((1)*sizeof(S_editorMarkerList))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_editorMarkerList))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 885);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 885);}; if ((ll = (S_editorMarkerList*) olcxMemoryFreeList[n]) == NULL) { ll = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 885);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; ll = (S_editorMarkerList *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) ll); }}; while (ll==NULL) { freeOldestOlcx(); { int n = (int) (((char*)(((1)*sizeof(S_editorMarkerList))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_editorMarkerList))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 885);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 885);}; if ((ll = (S_editorMarkerList*) olcxMemoryFreeList[n]) == NULL) { ll = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 885);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; ll = (S_editorMarkerList *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) ll); }}; }};
                { (ll)->d = m; (ll)->usage = l1->usage; (ll)->next = *diff1;};
                *diff1 = ll;
                l1 = l1->next;
        }
        while (l2 != NULL) {
                m = editorCrNewBufferMarker(l2->d->buffer, l2->d->offset);
                { { int n = (int) (((char*)(((1)*sizeof(S_editorMarkerList))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_editorMarkerList))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 892);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 892);}; if ((ll = (S_editorMarkerList*) olcxMemoryFreeList[n]) == NULL) { ll = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 892);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; ll = (S_editorMarkerList *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) ll); }}; while (ll==NULL) { freeOldestOlcx(); { int n = (int) (((char*)(((1)*sizeof(S_editorMarkerList))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_editorMarkerList))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 892);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 892);}; if ((ll = (S_editorMarkerList*) olcxMemoryFreeList[n]) == NULL) { ll = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 892);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; ll = (S_editorMarkerList *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) ll); }}; }};
                { (ll)->d = m; (ll)->usage = l2->usage; (ll)->next = *diff2;};
                *diff2 = ll;
                l2 = l2->next;
        }
}
void editorScheduleModifiedBuffersToUpdate() {
        int i;
        S_editorBufferList *ll;
        for(i=0; i<s_editorBufferTab.size; i++) {
                for(ll=s_editorBufferTab.tab[i]; ll!=NULL; ll=ll->next) {
                        if (ll->f->b.modified) {
                                s_fileTab.tab[ll->f->ftnum]->b.scheduledToUpdate = 1;
                        }
                }
        }
}
static S_editorBufferList *editorComputeAllBuffersList() {
        int i;
        S_editorBufferList *ll, *rr, *res;
        res = NULL;
        for(i=0; i<s_editorBufferTab.size; i++) {
                for(ll=s_editorBufferTab.tab[i]; ll!=NULL; ll=ll->next) {
                        { { int n = (int) (((char*)(((1)*sizeof(S_editorBufferList))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_editorBufferList))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 918);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 918);}; if ((rr = (S_editorBufferList*) olcxMemoryFreeList[n]) == NULL) { rr = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 918);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; rr = (S_editorBufferList *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) rr); }}; while (rr==NULL) { freeOldestOlcx(); { int n = (int) (((char*)(((1)*sizeof(S_editorBufferList))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_editorBufferList))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "editor.c", 918);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "editor.c", 918);}; if ((rr = (S_editorBufferList*) olcxMemoryFreeList[n]) == NULL) { rr = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "editor.c", 918);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; rr = (S_editorBufferList *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) rr); }}; }};
                        { (rr)->f = ll->f; (rr)->next = res;};
                        res = rr;
                }
        }
        return(res);
}
static void editorFreeBufferListButNotBuffers(S_editorBufferList *list) {
        S_editorBufferList *ll, *nn;
        ll=list;
        while (ll!=NULL) {
                nn = ll->next;
                { int n = (int) (((char*)((sizeof(S_editorBufferList))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)((sizeof(S_editorBufferList))))-1) & (STANDARD_ALLIGNEMENT-1)))); * (void **) ll = olcxMemoryFreeList[n]; olcxMemoryFreeList[n] = ll;};
                ll = nn;
        }
}
static int editorBufferNameLess(S_editorBufferList*l1,S_editorBufferList*l2) {
        return(strcmp(l1->f->name, l2->f->name));
}
int editorMapOnNonexistantFiles(
                char *dirname,
                void (*fun)(char *file, char *a1,char *a2,S_completions *a3,void *a4,int *a5),
                int deep,
                char *a1,
                char *a2,
                S_completions *a3,
                void *a4,
                int *a5
        ) {
        int i, dlen, fnlen, res, lastMappedLen;
        S_editorBufferList *ll, *bl;
        char *ss, *lastMapped;
        char fname[MAX_FILE_NAME_SIZE];
        struct stat st;
        res = 0;
        dlen = strlen(dirname);
        bl = editorComputeAllBuffersList();
        { S_editorBufferList *_macrores; _macrores = (bl); { S_editorBufferList *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (editorBufferNameLess(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (bl) = _macrores;};
        ll = bl;
        while(ll!=NULL) {
                if (fnnCmp(ll->f->name, dirname, dlen)==0
                        && (ll->f->name[dlen]=='/' || ll->f->name[dlen]=='\\')) {
                        if (deep == DEEP_ONE) {
                                ss = strchr(ll->f->name+dlen+1, '/');
                                if (ss==NULL) ss = strchr(ll->f->name+dlen+1, '\\');
                                if (ss==NULL) {
                                        strcpy(fname, ll->f->name+dlen+1);
                                        fnlen = strlen(fname);
                                } else {
                                        fnlen = ss-(ll->f->name+dlen+1);
                                        strncpy(fname, ll->f->name+dlen+1, fnlen);
                                        fname[fnlen]=0;
                                }
                        } else {
                                strcpy(fname, ll->f->name+dlen+1);
                                fnlen = strlen(fname);
                        }
                        if (stat(ll->f->name, &st)!=0) {
                                (*fun)(fname, a1, a2, a3, a4, a5);
                                res = 1;
                                lastMapped = ll->f->name;
                                lastMappedLen = dlen+1+fnlen;
                                ll = ll->next;
                                while (ll!=NULL
                                           && fnnCmp(ll->f->name, lastMapped, lastMappedLen)==0
                                           && (ll->f->name[lastMappedLen]=='/' || ll->f->name[lastMappedLen]=='\\')) {
                                        ll = ll->next;
                                }
                        } else {
                                ll = ll->next;
                        }
                } else {
                        ll = ll->next;
                }
        }
        editorFreeBufferListButNotBuffers(bl);
        return(res);
}
static void editorCloseBuffer(S_editorBufferList *memb, int ii) {
        S_editorBufferList **ll;
        for(ll= &s_editorBufferTab.tab[ii]; (*ll)!=NULL; ll = &(*ll)->next) {
                if (*ll == memb) break;
        }
        if (*ll == memb) {
                *ll = (*ll)->next;
                editorFreeBuffer(memb);
        }
}
void editorCloseBufferIfClosable(char *name) {
        S_editorBuffer dd;
        S_editorBufferList ddl, *memb, **ll;
        int ii;
        fillEmptyEditorBuffer(&dd, name, 0, name);
        { (&ddl)->f = &dd; (&ddl)->next = NULL;};
        if (editorBufferTabIsMember(&s_editorBufferTab, &ddl, &ii, &memb)) {
                if (( memb->f->b.textLoaded && memb->f->markers==NULL && memb->f->name==memb->f->fileName && ! memb->f->b.modified)) {
                        editorCloseBuffer(memb, ii);
                }
        }
}
void editorCloseAllBuffersIfClosable() {
        int i;
        S_editorBufferList *ll,*nn;
        S_editorMarker *m, *mm;
        for(i=0; i<s_editorBufferTab.size; i++) {
                for(ll=s_editorBufferTab.tab[i]; ll!=NULL;) {
                        nn = ll->next;
                        if (( ll->f->b.textLoaded && ll->f->markers==NULL && ll->f->name==ll->f->fileName && ! ll->f->b.modified)) editorCloseBuffer(ll, i);
                        ll = nn;
                }
        }
}
void editorCloseAllBuffers() {
        int i;
        S_editorBufferList *ll,*nn;
        S_editorMarker *m, *mm;
        for(i=0; i<s_editorBufferTab.size; i++) {
                for(ll=s_editorBufferTab.tab[i]; ll!=NULL;) {
                        nn = ll->next;
                        editorFreeBuffer(ll);
                        ll = nn;
                }
                s_editorBufferTab.tab[i] = NULL;
        }
}
void editorTest() {
        S_editorBuffer *buff;
}
